/*
 * WSO2 User Management Remote API
 * This document specifies a **RESTful API** for WSO2 **User Management**.  It is written with [swagger 2](http://swagger.io/). 
 *
 * OpenAPI spec version: v1.0
 * Contact: architecture@wso2.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package org.wso2.carbon.apimgt.rest.integration.tests.scim.model;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * UserSearch
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-04-17T00:32:36.849+05:30")
public class UserSearch {
  @JsonProperty("startIndex")
  private Integer startIndex = null;

  @JsonProperty("count")
  private Integer count = null;

  @JsonProperty("filter")
  private String filter = null;

  @JsonProperty("schemas")
  private List<String> schemas = null;

  @JsonProperty("attributes")
  private List<String> attributes = null;

  public UserSearch startIndex(Integer startIndex) {
    this.startIndex = startIndex;
    return this;
  }

   /**
   * The index of the first element in the result. 
   * @return startIndex
  **/
  @ApiModelProperty(example = "1", value = "The index of the first element in the result. ")
  public Integer getStartIndex() {
    return startIndex;
  }

  public void setStartIndex(Integer startIndex) {
    this.startIndex = startIndex;
  }

  public UserSearch count(Integer count) {
    this.count = count;
    return this;
  }

   /**
   * Number of elements returned in the paginated result. 
   * @return count
  **/
  @ApiModelProperty(value = "Number of elements returned in the paginated result. ")
  public Integer getCount() {
    return count;
  }

  public void setCount(Integer count) {
    this.count = count;
  }

  public UserSearch filter(String filter) {
    this.filter = filter;
    return this;
  }

   /**
   * A filter expression to request a subset of the result.
   * @return filter
  **/
  @ApiModelProperty(value = "A filter expression to request a subset of the result.")
  public String getFilter() {
    return filter;
  }

  public void setFilter(String filter) {
    this.filter = filter;
  }

  public UserSearch schemas(List<String> schemas) {
    this.schemas = schemas;
    return this;
  }

  public UserSearch addSchemasItem(String schemasItem) {
    if (this.schemas == null) {
      this.schemas = new ArrayList<String>();
    }
    this.schemas.add(schemasItem);
    return this;
  }

   /**
   * Get schemas
   * @return schemas
  **/
  @ApiModelProperty(value = "")
  public List<String> getSchemas() {
    return schemas;
  }

  public void setSchemas(List<String> schemas) {
    this.schemas = schemas;
  }

  public UserSearch attributes(List<String> attributes) {
    this.attributes = attributes;
    return this;
  }

  public UserSearch addAttributesItem(String attributesItem) {
    if (this.attributes == null) {
      this.attributes = new ArrayList<String>();
    }
    this.attributes.add(attributesItem);
    return this;
  }

   /**
   * Get attributes
   * @return attributes
  **/
  @ApiModelProperty(value = "")
  public List<String> getAttributes() {
    return attributes;
  }

  public void setAttributes(List<String> attributes) {
    this.attributes = attributes;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserSearch userSearch = (UserSearch) o;
    return Objects.equals(this.startIndex, userSearch.startIndex) &&
        Objects.equals(this.count, userSearch.count) &&
        Objects.equals(this.filter, userSearch.filter) &&
        Objects.equals(this.schemas, userSearch.schemas) &&
        Objects.equals(this.attributes, userSearch.attributes);
  }

  @Override
  public int hashCode() {
    return Objects.hash(startIndex, count, filter, schemas, attributes);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserSearch {\n");
    
    sb.append("    startIndex: ").append(toIndentedString(startIndex)).append("\n");
    sb.append("    count: ").append(toIndentedString(count)).append("\n");
    sb.append("    filter: ").append(toIndentedString(filter)).append("\n");
    sb.append("    schemas: ").append(toIndentedString(schemas)).append("\n");
    sb.append("    attributes: ").append(toIndentedString(attributes)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

